//InitGridOffDiag
//InitGridDiag
//get_atom_col_block
//get_atom_connect_block
#ifndef GRID_JOBS_H_
#define GRID_JOBS_H_
#include <iostream>
#include <complex>
using namespace std;

//Since the T,t-dagger,U, and U-dagger blocks are set once in the beginning, and then are never
//needed to be up dated, this only sets up those blocks and ignores the diagonal blocks.
void InitGridOffDiag(block stm[300][3], double energy, double BField, double atomCoordinates[3600][3])
{
	for(int i=0; i<299; i++)
	{
		stm[i+1][0].set_values(i, 0, energy, BField, 'T', atomCoordinates);
	} //endfor

	for(int i=1; i<300; i++)
	{
		stm[i][2].set_values(i, 2, energy, BField, 'W', atomCoordinates);
	} //endfor

	stm[0][0].set_values(0, 0, energy, BField, 'U', atomCoordinates);
	stm[299][2].set_values(299, 2, energy, BField, 'Q', atomCoordinates);
} //end InitGridOffDiag


//Sets up only the diagonal blocks
void InitGridDiag(block stm[300][3], double energy, double BField, double atomCoordinates[3600][3])
{
	for(int i=0; i<300; i++)
	{
		stm[i][1].set_values(i, 100, energy, BField, 'D', atomCoordinates);
	} //endfor
} //end InitGridDiag


//Returns the value of the block that an atom belongs to.
//For instance, in a 3600 atom model, atom 1359 will belong to block 133.
int get_atom_col_block(int atom)
{
	return (floor(atom / 12));
} //end get_atom_col_block


int get_atom_connect_block(int atom1, int atom2)
{
	int temp = floor(atom1 / 12);
	int temp2 = floor(atom2 / 12);
	int result;

	if(temp == temp2)
	{
		//Then they are in the main diagonal
		result = 1;
	} //endif
	else if(temp == temp2+1 && temp2!= 299)
	{
		//They are in T/T-Dagger
		result = 0;
	} //endif
	else if(temp2 == temp+1 && temp != 299)
	{
		//They are in T/T-Dagger
		result = 2;
	} //endif
	else if(temp2 == 0 && temp == 299)
	{
		//They are in U/U-Dagger
		result = 3;
	} //endif
	else if(temp2 == 299 && temp == 0)
	{
		//They are in U/U-Dagger
		result = 4;
	} //endif
	else result = 999999;

	return (result);
} //end get_atom_connect_block

#endif /* GRID_JOBS_H_ */
