#ifndef INTEGRATION_H_
#define INTEGRATION_H_
#include <cmath>
using namespace std;

double integrate(double IVvalues[][2], const int IVcount, double stepSize, double vsd)
{
	//Initializations and declarations
	double currtofe[IVcount],
		  c1 = 14./45, c2 = 64./45, c3 = 24./45, c4 = c2, c5 = c1,
		  corrsd = 0, therm = .03,
		  energy, fermi1, fermi2, emu1 = -vsd/2, emu2 = vsd/2;
	
	for(int i=0; i<IVcount; i++)
	{
		energy = IVvalues[i][0];
		fermi1 = 1 / (exp((energy-emu1) / therm) + 1);
		fermi2 = 1 / (exp((energy-emu2) / therm) + 1);
		if(abs(energy) < stepSize) currtofe[i] = 0;
		else currtofe[i] = 2 * IVvalues[i][1] * (fermi1-fermi2);
	} //endfor

	for(int i=0; i<IVcount-4; i+=4)
	{
		corrsd += stepSize * (c1*currtofe[i] + c2*currtofe[i+1] + c3*currtofe[i+2] + c4*currtofe[i+3] + c5*currtofe[i+4]);
	}

	return corrsd;
} //end integrate

#endif /* INTEGRATION_H_ */

/*
ntofe = IVcount
h = stepSize
venergy(i) = IVvalues[i][0]
vtofe(i) = IVvalues[i][1]
*/
